// Generated by CoffeeScript 1.7.1

/*
  Add Optical Flares
    (C) あかつきみさき(みくちぃP)

  このスクリプトについて
    アクティブなコンポジションのサイズに合わせた新規レイヤーを作成し,Optical Flaresエフェクトを適用するスクリプトです.

    このスクリプトは以下の値を操作します.
      レイヤーブレンドモード : スクリーン
      Source Type : 3D
      Position Z : 2000
      Flicker - Speed : 50
      Flicker - Amount : 50

  使用方法
    コンポジションをアクティブにしてからスクリプトを実行してください.

  動作環境
    Adobe After Effects CS5.5以上

  バージョン情報
    2014/08/21 Ver 1.0.0 Release
 */

(function() {
  var ADBE_EFFECT_PARADE, ADBE_POSITION, ADBE_TRANSFORM_GROUP, AMOUNT_VALUE, AOFData, COLOR_BLACK, POSITION_Z_VALUE, SOURCE_TYPE_VALUE, SPEED_VALUE, VC_AMOUNT, VC_OPTICAL_FLARES, VC_POSITION_Z, VC_SOURCE_TYPE, VC_SPEED, actComp, entryFunc, hasTargetEffect, isCompActive, runAEVersionCheck, undoEntryFunc;

  AOFData = (function() {
    var canRunVersion, scriptName, scriptURLName, scriptURLVersion, scriptVersionNumber;
    scriptName = "Add Optical Flares";
    scriptURLName = "AddOpticalFlares";
    scriptVersionNumber = "1.0.0";
    scriptURLVersion = 100;
    canRunVersion = 10.5;
    return {
      getScriptName: function() {
        return scriptName;
      },
      getScriptURLName: function() {
        return scriptURLName;
      },
      getScriptVersionNumber: function() {
        return scriptVersionNumber;
      },
      getScriptURLVersion: function() {
        return scriptURLVersion;
      },
      getCanRunVersion: function() {
        return canRunVersion;
      }
    };
  })();

  COLOR_BLACK = [0, 0, 0];

  ADBE_TRANSFORM_GROUP = "ADBE Transform Group";

  ADBE_POSITION = "ADBE Position";

  ADBE_EFFECT_PARADE = "ADBE Effect Parade";

  VC_OPTICAL_FLARES = "VIDEOCOPILOT OpticalFlares";

  VC_SOURCE_TYPE = "VIDEOCOPILOT OpticalFlares-0009";

  VC_SPEED = "VIDEOCOPILOT OpticalFlares-0051";

  VC_AMOUNT = "VIDEOCOPILOT OpticalFlares-0052";

  VC_POSITION_Z = "VIDEOCOPILOT OpticalFlares-0060";

  SOURCE_TYPE_VALUE = 2;

  SPEED_VALUE = 50;

  AMOUNT_VALUE = 50;

  POSITION_Z_VALUE = 2000;

  runAEVersionCheck = function(AEVersion) {
    if (parseFloat(app.version) < AEVersion) {
      alert("This script requires After Effects " + (AEVersion.toFixed(1)) + " or greater.");
      return false;
    } else {
      return true;
    }
  };

  isCompActive = function(selComp) {
    if (!(selComp && selComp instanceof CompItem)) {
      alert("Select Composition");
      return false;
    } else {
      return true;
    }
  };

  hasTargetEffect = function(targetEffect) {
    var i, _i, _ref;
    for (i = _i = 0, _ref = app.effects.length; _i < _ref; i = _i += 1) {
      if (String(targetEffect) === String(app.effects[i].matchName)) {
        return true;
      }
    }
    alert("" + targetEffect + " Effect Not Found");
    return false;
  };

  entryFunc = function() {
    var targetEffect, targetLayer;
    targetLayer = actComp.layers.addSolid(COLOR_BLACK, "Optical Flares", actComp.width, actComp.height, 1.0, actComp.duration);
    targetLayer.blendingMode = BlendingMode.SCREEN;
    targetEffect = targetLayer.property(ADBE_EFFECT_PARADE).addProperty(VC_OPTICAL_FLARES);
    targetEffect.property(VC_SOURCE_TYPE).setValue(SOURCE_TYPE_VALUE);
    targetEffect.property(VC_SPEED).setValue(SPEED_VALUE);
    targetEffect.property(VC_AMOUNT).setValue(AMOUNT_VALUE);

    /*
    このコードでAEのUIを更新してエフェクトプロパティがhiddenで値が更新できないエラーを回避する
    actComp.time = actComp.time
     */
    actComp.time = actComp.time;
    targetEffect.property(VC_POSITION_Z).setValue(POSITION_Z_VALUE);
    return 0;
  };

  undoEntryFunc = function(data) {
    app.beginUndoGroup(data.getScriptName());
    entryFunc();
    app.endUndoGroup();
    return 0;
  };


  /*
  メイン処理開始
   */

  if (!runAEVersionCheck(AOFData.getCanRunVersion())) {
    return 0;
  }

  actComp = app.project.activeItem;

  if (!isCompActive(actComp)) {
    return 0;
  }

  if (!hasTargetEffect(VC_OPTICAL_FLARES)) {
    return 0;
  }

  undoEntryFunc(AOFData);

  return 0;

}).call(this);
